Subject: Re: bug#48015: 28.0.50; ELPA package compilation fails

From: Michael Albinus <[email-masked]>
Date: Tue, 27 Apr 2021 14:05:18 +0200

Stefan Monnier <[email-masked]> writes:

> The core problem that I see is the following:
>
> - Emacs's tramp gets loaded
> - We go to a Tramp-controlled default-directory
> - We call `package--load-files-for-activation`
>   - This starts by loading ~/.emacs.d/elpa/tramp-NN.MM/tramp-autoloads.el
>     This calls `tramp-register-autoload-file-name-handlers`.
>   - At this point, `package--load-files-for-activation` would like to
>     continue by (re)loading the new Tramp files, such as `tramp-compat`
>     and friends in the same order that they have been loaded
>     (i.e. `tramp-compat.el` before `tramp.el`).
>   - But before it gets a chance to do that, the file-name handlers
>     call `tramp-autoload-file-name-handler` because of `default-directory`,
>     which does (load "tramp" 'noerror 'nomessage), which loads the new
>     `tramp.el` before we got a change to load the new `tramp-compat.el`,
>     which then leads to an error when the new code in `tramp.el` calls
>     a new function from `tramp-compat.el` (which happens to be
>     `tramp-compat-thread-yield` AFAICT).
>
> At this point, I'm not sure how best to fix the problem.
> Maybe replacing (load "tramp" 'noerror 'nomessage) with
> (require 'tramp nil t) is all it takes.
> Or maybe a better option is to arrange the autoloads such that
> `tramp-register-autoload-file-name-handlers` doesn't "unload/unregister" file
> handlers that have already been loaded so that the directory that was
> already under Tramp's control doesn't re-trigger a call to
> `tramp-autoload-file-name-handler`?

What I don't understand: when (load "tramp" 'noerror 'nomessage) is
called, default-directory is already local due to a let-binding.

Anyway, even if the compilation runs through in case of a local
default-directory, the resulting *.elc files have errors. I have quit
Emacs (from the first recipe), and then I have started

emacs -Q -L ~/.emacs.d/elpa/tramp-2.5.0.3/ /ssh::

There are further errors, which are related to a wrong
tramp-compat.el. Only my new command tramp-recompile-elpa fixes this.

>         Stefan

Best regards, Michael.